﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.CalcEngine;
using Infragistics.Win.UltraWinCalcManager.FormulaBuilder;
using System.Diagnostics;
using System.Reflection;

namespace WindowsFormsApplication10
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            MyCustomFunction custFunc = new MyCustomFunction(ultraGrid1.Rows);
            ultraCalcManager1.RegisterUserDefinedFunction(custFunc);
            ShowFormulaBuilderDialog_2(ultraGrid1.DisplayLayout.Bands[0].Columns["formula5"] as IFormulaProvider);
        }

        private void ShowFormulaBuilderDialog_2(IFormulaProvider formulaProvider)
        {
            FormulaBuilderDialog formulaBuilderDialog = new FormulaBuilderDialog(formulaProvider);
            formulaProvider.Formula = "GroupByColumnSumFunction( [part1], [part4] )";
        }

    }

    public class MyCustomFunction : Infragistics.Win.CalcEngine.UltraCalcFunction
    {
        #region Constructors
        RowsCollection Rows;
        public MyCustomFunction(RowsCollection rows)
        {
            Rows = rows;
        }
        #endregion Constructors

        private Infragistics.Win.CalcEngine.UltraCalcValue retVAL;

        private string[] argDescriptors = new string[] { "Choose a column to group by your results", "Choose a the sum column" };
        public override string[] ArgDescriptors
        {
            get { return argDescriptors; }
        }

        private string[] argList = new string[] { "Group By Column", "Sum values" };
        public override string[] ArgList
        {
            get { return argList; }
        }

        public override string Category
        {
            get { return "Custom Functions"; }
        }

        public override string Description
        {
            get { return "This is custom function, which return the sum of columns, group by specific column"; }
        }


        protected override Infragistics.Win.CalcEngine.UltraCalcValue Evaluate(Infragistics.Win.CalcEngine.UltraCalcNumberStack numberStack, int argumentCount)
        {
            UltraCalcValue param1 = numberStack.Pop();
            UltraCalcValue param2 = numberStack.Peek();

            string[] ValueColumn = new string[5];
            ValueColumn = param1.Value.ToString().Split('/');

            string[] ind = new string[5];
            ind = ValueColumn[3].Split(new char[2] { '(', ')' });

            int gg = Convert.ToInt32(ind[1].ToString());

            string[] GroupColumn = new string[5];
            GroupColumn = param2.Value.ToString().Split('/');

            string FilterValue = param2.ToString();

            UltraGridColumn col = Rows[0].Band.Columns[2];
            var w = Rows.Where(z => z.Index <= gg && z.GetCellText(z.Band.Columns[0]) == FilterValue).Sum(s => Convert.ToDecimal(s.GetCellText(col)));
            Infragistics.Win.CalcEngine.UltraCalcValue retVAL = new UltraCalcValue(w);

            return retVAL;

            // Old Formula
            //UltraCalcValue param1 = numberStack.Pop();
            //UltraCalcValue param2 = numberStack.Peek();

            //string[] ValueColumn = new string[5];
            //ValueColumn = param1.Value.ToString().Split('/');

            //string[] GroupColumn = new string[5];
            //GroupColumn = param2.Value.ToString().Split('/');

            //string FilterValue = param2.ToString();

            //Infragistics.Win.CalcEngine.UltraCalcValue retVAL = new Infragistics.Win.CalcEngine.UltraCalcValue(Rows.Where(p => p.GetCellText(Rows.Band.Columns[GroupColumn[4]]) == FilterValue).Sum(s => Convert.ToDecimal(s.GetCellValue(Rows.Band.Columns[ValueColumn[4]]))));
            //return retVAL;
        }

        public override int MaxArgs
        {
            get { return 2; }
        }

        public override int MinArgs
        {
            get { return 2; }
        }

        public override string Name
        {
            get { return "GroupByColumnSumFunction"; }
        }
    }
}
